<!DOCTYPE html>
<html xmlns:MadCap="http://www.madcapsoftware.com/Schemas/MadCap.xsd" lang="en-us" xml:lang="en-us" class="no-feedback" data-mc-search-type="Stem" data-mc-help-system-file-name="index.xml" data-mc-path-to-help-system="../../" data-mc-target-type="WebHelp2" data-mc-runtime-file-type="Topic" data-mc-preload-images="false" data-mc-in-preview-mode="false" data-mc-toc-path="Credentials">
    <head>
        <meta charset="utf-8" />
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><title>Reusing Credentials</title>
        
        <link href="../../Skins/Default/Stylesheets/TextEffects.css" rel="stylesheet" />
        <link href="../../Skins/Default/Stylesheets/Topic.css" rel="stylesheet" />
        <link href="../Resources/Stylesheets/Styles.css" rel="stylesheet" />
        <script src="../../Resources/Scripts/jquery.min.js">
        </script>
        <script src="../../Resources/Scripts/plugins.min.js">
        </script>
        <script src="../../Resources/Scripts/MadCapAll.js">
        </script>
    </head>
    <map id="map1" name="map1">
        <area shape="rectangle" coords="840,44,1093,87" href="http://www.rapid7.com/products/metasploit/download.jsp" target="_blank" />
        <area shape="rectangle" coords="1107,48,1211,80" href="http://www.rapid7.com/products/metasploit/" target="_blank" />
    </map>
    <body>
        <p class="MCWebHelpFramesetLink MCWebHelpFramesetLinkTop" style="display: none;"><a href="../../index.html#23-credentials/reusing-credentials.html">Open topic with navigation</a>
        </p>
        <h1>Reusing Credentials</h1>
        <p>With exceedingly more and more stringent password requirements, credential reuse is becoming a common issue within many organizations. Users inundated with complex password policies may resort to reusing the same password across multiple accounts so that they can easily manage their credentials. This can cause major security issues when those credentials are compromised. For example, if an attacker is able to obtain valid credentials on one target, they can try those credentials on other targets to further compromise the network. </p>
        <p> To help an organization audit their passwords, you can reuse credentials to identify additional targets that will be vulnerable if a particular credential is compromised. Credentials Reuse is a <span class="VariablesProductName">Metasploit Pro</span> feature reuses validated credentials  to attempt to authenticate to additional targets. This feature is useful when you have validated or known credentials that you want to try on a set of targets. For example, if you were able to obtain an NTLM hash on a target, you should try to reuse that hash on other SMB targets. If a system administrator commonly deploys the default configuration for a system, the likelihood that the credential will work is high. </p>
        <h2>Credentials Reuse Workflow</h2>
        <p>Credentials Reuse provides guided workflow for the required tasks that need to be configured. Each task in the workflow is displayed on its own tab. You can click on any of the tabs to switch between the different tasks in the workflow; however, you must complete each task before you can move to the next. </p>
        <p>The Credentials workflow is shown below:</p>
        <p>
            <img src="../Resources/Images/creds/creds-reuse-workflow_433x228.png" style="width: 433;height: 228;" />
        </p>
        <p style="page-break-after: avoid;">The workflow is quite simple and comprises of four steps:</p>
        <ol>
            <li value="1">Select the targets that you want to try the credentials on.  </li>
            <li value="2">Select the credentials that you want to use to authenticate to the selected targets. </li>
            <li value="3">Configure the reuse settings, such as the timeout and validation limits, and review the target that you want to use. </li>
            <li value="4">Launch the task. </li>
        </ol>
        <h3>Credentials Reuse Targets</h3>
        <p>Credentials Reuse utilizes several login scanners from the Metasploit Framework, which enable Credentials Reuse to target the following services: AFP, DB2, FTP, HTTP, HTTPS, MSSQL, MySQL, POP3, PostgreSQL, SMB, SNMP, SSH, telnet, VNC, and WinRM.</p>
        <p>Targets that do not have a login scanner, such as DCERPC, will be skipped. </p>
        <h2>Configuring and Running Credentials Reuse</h2>
        <ol>
            <li value="1">From within a project, select <b class="UISelection">Credentials &gt;&#160;Reuse</b>. <br /><br />The Credentials Reuse  workflow appears. The Targets tab displays first and shows you the targets that are available in the project. Targets, in this instance, are services. <span class="VariablesProductName">Metasploit Pro</span> pulls this data from the host and service data that is stored in the project. <br /><br /><img src="../Resources/Images/creds/creds-reuse-targets_381x137.png" style="width: 381;height: 137;" /></li>
            <li value="2">Select the targets that you want to try the credentials on. You can select as many targets as you want. When you are done selecting targets, click the <b class="UISelection">Add Target(s) to this list</b> button. The targets will be added to the Selected Targets list. <br /><br /><img src="../Resources/Images/creds/creds-reuse-add-button_382x203.png" style="width: 382;height: 203;" /><br /><br />You can use the <b class="UISelection">Select All</b> checkbox to choose all the targets in the project and the page navigation arrows to look through the targets list. If you want to view all targets in the project, select the <b class="UISelection">All</b> option from the <b class="UISelection">Show</b> dropdown menu. <br /><br /><img src="../Resources/Images/creds/creds-reuse-page-nav_376x141.png" style="width: 376;height: 141;" /><br /><br />You can also click on the <b class="UISelection">Filter</b> button to find targets based on host, service, port, operating system, protocol, and keyword. <br /><br /><img src="../Resources/Images/creds/creds-reuse-filter_400x160.png" style="width: 400;height: 160;" /></li>
            <li value="3">Click the <b class="UISelection">Next</b> button when you are done selecting targets. <br /><br />The Credentials tab displays and shows you the credentials that are available in the project. </li>
            <li value="4">Select the credentials that you want to reuse. You can select as many credentials as you want. When you are done selecting credentials, click the <b class="UISelection">Add Credential(s) to this list</b> button. The targets will be added to the Selected Credentials list.<br /><br /><img src="../Resources/Images/creds/creds-reuse-creds_377x201.png" style="width: 377;height: 201;" /><br /><br />You can use the <b class="UISelection">Select All</b> checkbox to choose all the targets in the project and the page navigation arrows to look through the credentials list. If you want to view all credentials in the project, select the <b class="UISelection">All</b> option from the <b class="UISelection">Show</b> dropdown menu. <br /><br /><img src="../Resources/Images/creds/creds-reuse-page-nav2_392x131.png" style="width: 392;height: 131;" /><br /><br />You can also click on the <b class="UISelection">Filter</b> button to find credentials based on validation status, username, password, private type, realm, and tag. <br /><br /><img src="../Resources/Images/creds/creds-reuse-filter2_405x162.png" style="width: 405;height: 162;" /></li>
            <li value="5">Select the <b class="UISelection">Next</b> button when you are done selecting credentials. <br /><br />The Review tab appears and shows you the options that you can set for Credentials Reuse and the targets and credentials that you have selected. <br /><br /><img src="../Resources/Images/creds/creds-reuse-review_416x193.png" style="width: 416;height: 193;" /><br /></li>
            <li value="6">If you want to control the timeout settings for Credentials Reuse, you can configure any of the following options: </li>
        </ol>
        <ul>
            <li class="numberedList2" value="1"><b>Service Timeout</b> - Sets the timeout, in seconds, for each target. </li>
            <li class="numberedList2" value="2"><b>Overall Timeout </b>- Sets the timeout for the entire Credentials Reuse task. </li>
            <li class="numberedList2" value="3"><b>Validate one credential per service</b> - Limits the number of credentials that are validated for a service on a host to one. Once a credential has been validated for a service, Credentials Reuse will stop testing with other credentials. </li>
        </ul>
        <ol start="7">
            <li value="7">Review the targets and credentials that you have selected for Credentials Reuse. <br /><br />If there are any that you want to remove, you can click on the <b class="UISelection">Remove 'X'</b> button located next to the target or credential or you can click on the <b class="UISelection">Remove 'X'</b> button located at the top of each list to remove all targets or credentials. <br /><br /><img src="../Resources/Images/creds/creds-reuse-remove-button_264x235.png" style="width: 264;height: 235;" /><br /><br />If there are targets or credentials you want to add, you can either click on the tab for the item you want to add or you can click on the <b class="UISelection">Go back and edit</b> link located at the bottom of the Selected Targets and Selected Credentials lists. <br /><br />If you want to see additional information for a particular target, you can click on the dropdown arrow located next to each target to display the operating system, port, and protocol. </li>
            <li value="8">Click the <b class="UISelection">Launch</b> button when you are ready to run Credentials Reuse. There is a launch button located at the top and bottom of the workflow. <br /><br /><img src="../Resources/Images/creds/creds-reuse-launch_408x190.png" style="width: 408;height: 190;" /><br /><br />When you launch Credentials Reuse, the Findings window appears and shows you the statistics for the task run. You can click on any of the statistic bubbles to view the details for that particular statistic. <br /><br /><img src="../Resources/Images/creds/creds-reuse-findings_415x222.png" style="width: 415;height: 222;" /><br /><br />The Findings window shows you the following statistics: </li>
            <li class="numberedList2" value="9"><b>Login attempts</b> - The total number of login attempts that were made. Credentials Reuse will only attempt logins for the following services: AFP, DB2, FTP, HTTP, HTTPS, MSSQL, MySQL, POP3, PostgreSQL, SMB, SNMP, SSH, telnet, VNC, and WinRM. Therefore, the Login Attempts may not include all of the targets that you have selected. The Login Attempts also shows you results for the login and when the login was last attempted. <br /></li>
            <li class="numberedList2" value="10"><b>Validated credentials</b> - The total number of credentials that successfully authenticated. </li>
            <li class="numberedList2" value="11"><b>Validated targets</b> - The total number of targets that were validated. </li>
            <li class="numberedList2" value="12"><b>Successful logins</b> - The total number of logins that were successful. This number is derived from the number of validated credentials and validated targets. </li>
        </ol>
        <p class="NoteList" data-mc-autonum="&lt;b&gt;Note:&lt;/b&gt; &#160;"><span class="autonumber"><span><b>Note:</b> &#160;</span></span>If <span class="VariablesProductName">Metasploit Pro</span> is able to identify a realm for a credential, it will update the credential with the realm information. You will be able to view the updated credential from the Manage Credentials page. </p>
    </body>
</html>